<template>
  <div class="checkout">
    <v-form
      v-show="pageLoaded"
      ref="checkoutForm"
      lazy-validation
      @submit.prevent
    >
      <v-row
        :class="[
          { 'pt-16 pl-5 pr-5': $vuetify.breakpoint.smAndDown },
          { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
        ]"
      >
        <v-col md="9">
          <v-row>
            <v-col>
              <h2 class="font-syne-bold">
                {{ $t('common.shipping') }}
              </h2>
              <p class="font-metropolis-regular font-14">
                {{ $t('common.shippingDesc') }}
              </p>
            </v-col>
          </v-row>

          <v-row>
            <v-col cols="12">
              <p class="font-metropolis-regular mb-0">
                {{ $t('form.deliveryAddress.text') }}
              </p>
            </v-col>
            <v-col v-if="addresses.length == 0" cols="12">
              <v-btn
                class="
                                            mt-5
                                            lowercase
                                            br-0
                                            pl-10
                                            pr-10
                                            font-syne-bold
                                        "
                color="badge"
                @click="gotoAddress"
              >
                {{ $t('buttons.addAddressBtn') }}
              </v-btn>
            </v-col>
            <v-col cols="12">
              <v-radio-group v-model="addressGroup" row>
                <v-radio
                  v-for="(address, a) in addresses"
                  :key="'address-' + a"
                  :value="address.id"
                  color="white"
                  off-icon="mdi-checkbox-blank-circle-outline"
                  on-icon="mdi-checkbox-marked-circle-outline"
                  :rules="[requiredRules]"
                  @click="selectAddress"
                >
                  <template v-slot:label>
                    <v-row>
                      <v-col cols="12">
                        <p
                          class="
                                                        font-metropolis-regular
                                                        mb-0
                                                    "
                        >
                          {{ address.firstName }}
                          {{ address.lastName }}
                        </p>
                        <p
                          class="
                                                        font-metropolis-regular
                                                        font-12
                                                        text-grey
                                                        mb-0
                                                    "
                        >
                          {{ address.address1 }},
                        </p>
                        <p
                          class="
                                                        font-metropolis-regular
                                                        font-12
                                                        text-grey
                                                        mb-0
                                                    "
                        >
                          {{
                            address.address2
                              ? address.address2 +
                                ', ' +
                                address.city
                              : address.city
                          }},
                        </p>
                        <p
                          class="
                                                        font-metropolis-regular
                                                        font-12
                                                        text-grey
                                                        mb-0
                                                    "
                        >
                          {{ address.postcode }},
                          {{ address.state }},
                        </p>
                        <p
                          class="
                                                        font-metropolis-regular
                                                        font-12
                                                        text-grey
                                                        mb-0
                                                    "
                        >
                          {{ address.country }}
                        </p>
                      </v-col>
                    </v-row>
                  </template>
                </v-radio>
              </v-radio-group>
            </v-col>
            <v-col cols="12">
              <v-btn
                class="
                                    mt-5
                                    lowercase
                                    br-0
                                    pl-10
                                    pr-10
                                    font-syne-bold
                                    border-white
                                    transparent-bg
                                "
                @click="addNewAddress"
              >
                <v-icon left>
                  mdi-plus
                </v-icon>{{
                  $t('buttons.useDifferentAddressBtn')
                }}
              </v-btn>
            </v-col>
            <v-col v-show="!panel" cols="12">
              <v-form
                v-show="pageLoaded"
                ref="addressForm"
                lazy-validation
                @submit.prevent
              >
                <v-row
                  :class="[
                    {
                      'pl-0 pr-0':
                        $vuetify.breakpoint.smAndDown,
                    },
                  ]"
                >
                  <v-col cols="12">
                    <!-- ADD ADDRESS FORM -->
                    <v-row>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- FIRST NAME -->
                        <v-text-field
                          ref="name"
                          v-model="
                            form.firstName.value
                          "
                          :label="
                            $t(
                              'form.firstName.text'
                            )
                          "
                          :placeholder="
                            $t(
                              'form.firstName.placeholder'
                            )
                          "
                          solo
                          required
                          :rules="[requiredRules]"
                        />
                      </v-col>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- LAST NAME -->
                        <v-text-field
                          ref="name"
                          v-model="
                            form.lastName.value
                          "
                          :label="
                            $t('form.lastName.text')
                          "
                          :placeholder="
                            $t(
                              'form.lastName.placeholder'
                            )
                          "
                          solo
                          required
                          :rules="[requiredRules]"
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- MOBILE -->
                        <v-text-field
                          ref="mobile"
                          v-model="form.mobile.value"
                          :label="
                            $t('form.mobile.text')
                          "
                          :placeholder="
                            $t(
                              'form.mobile.placeholder'
                            )
                          "
                          solo
                          required
                          :rules="[requiredRules]"
                        />
                      </v-col>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- COMPANY -->
                        <v-text-field
                          ref="company"
                          v-model="form.company.value"
                          :label="
                            $t('form.company.text')
                          "
                          :placeholder="
                            $t(
                              'form.company.placeholder'
                            )
                          "
                          solo
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="12"
                        class="form-field"
                      >
                        <!-- ADDRESS 1 -->
                        <v-text-field
                          ref="address1"
                          v-model="
                            form.address1.value
                          "
                          :label="
                            $t('form.address1.text')
                          "
                          :placeholder="
                            $t(
                              'form.address1.placeholder'
                            )
                          "
                          solo
                          :rules="[requiredRules]"
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="12"
                        class="form-field"
                      >
                        <!-- ADDRESS 2 -->
                        <v-text-field
                          ref="address2"
                          v-model="
                            form.address2.value
                          "
                          :label="
                            $t('form.address2.text')
                          "
                          :placeholder="
                            $t(
                              'form.address2.placeholder'
                            )
                          "
                          solo
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- CITY -->
                        <v-text-field
                          ref="city"
                          v-model="form.city.value"
                          :label="
                            $t('form.city.text')
                          "
                          :placeholder="
                            $t(
                              'form.city.placeholder'
                            )
                          "
                          solo
                          :rules="[requiredRules]"
                        />
                      </v-col>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- STATE -->
                        <v-text-field
                          ref="state"
                          v-model="form.state.value"
                          :label="
                            $t('form.state.text')
                          "
                          :placeholder="
                            $t(
                              'form.state.placeholder'
                            )
                          "
                          solo
                          :rules="[requiredRules]"
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- POSTCODE -->
                        <v-text-field
                          ref="postcode"
                          v-model="
                            form.postcode.value
                          "
                          :label="
                            $t('form.postcode.text')
                          "
                          :placeholder="
                            $t(
                              'form.postcode.placeholder'
                            )
                          "
                          solo
                          :rules="[requiredRules]"
                        />
                      </v-col>
                      <v-col
                        cols="6"
                        class="form-field"
                      >
                        <!-- COUNTRY -->
                        <v-select
                          ref="country"
                          v-model="form.country.value"
                          :label="
                            $t('form.country.text')
                          "
                          :items="countryList"
                          solo
                          required
                          :rules="[requiredRules]"
                        />
                      </v-col>
                    </v-row>
                    <!-- SUBMIT BUTTON -->
                    <v-row>
                      <v-col>
                        <v-btn
                          :block="
                            $vuetify.breakpoint
                              .smAndDown
                          "
                          class="
                                                        lowercase
                                                        br-0
                                                        pl-10
                                                        pr-10
                                                        font-syne-bold
                                                    "
                          color="badge"
                          :disabled="
                            isAddAddressBtnDisabled
                          "
                          :loading="
                            isAddAddressLoaderBtnDisabled
                          "
                          @click="validateAddressForm"
                        >
                          {{
                            $t(
                              'buttons.useThisAddressBtn'
                            )
                          }}
                        </v-btn>
                      </v-col>
                    </v-row>
                  </v-col>
                </v-row>
              </v-form>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="12" md="6">
              <v-expansion-panels v-model="menu1">
                <v-expansion-panel>
                  <v-expansion-panel-header
                    class="font-metropolis-regular"
                  >
                    {{
                      deliveryDate != ''
                        ? formatDate(deliveryDate)
                        : $t('form.deliveryDate.text')
                    }}
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <client-only>
                      <date-picker
                        ref="datePick"
                        v-model="deliveryDate"
                        format="yyyy-MM-dd"
                        :disabled-dates="disabledDates"
                        :inline="true"
                        @selected="menu1 = false"
                      />
                    </client-only>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </v-col>
            <v-col>
              <!-- DELIVERY TIME -->
              <v-select
                ref="deliveryTime"
                v-model="form.deliveryTime.value"
                :label="$t('form.deliveryTime.text')"
                :items="timeslots"
                item-text="name"
                item-value="id"
                :error-messages="form.deliveryTime.error"
                :rules="[requiredRules]"
              />
            </v-col>
          </v-row>
          <v-row v-if="$vuetify.breakpoint.mdAndUp">
            <v-col class="pt-0 text-left">
              <v-row v-if="surcharges">
                <v-col class="pt-0">
                  <v-row>
                    <v-col>
                      <h2 class="font-syne-bold">
                        {{ $t('common.payment') }}
                      </h2>
                    </v-col>
                  </v-row>
                  <p
                    v-if="surcharges"
                    class="
                                            cart-text
                                            text-white
                                            pt-2
                                            pb-0
                                            mb-2
                                        "
                  >
                    {{ $t('cart.extraFee') }}
                    <v-tooltip
                      v-model="extraFeeTooltip"
                      right
                    >
                      <template
                        v-slot:activator="{ on, attrs }"
                      >
                        <v-btn
                          icon
                          x-small
                          v-bind="attrs"
                          v-on="on"
                        >
                          <v-icon
                            color="badge lighten-1"
                          >
                            mdi-information-outline
                          </v-icon>
                        </v-btn>
                      </template>
                      <span>Programmatic tooltip</span>
                    </v-tooltip>

                    {{ currencyName }}
                    {{ surcharges }}
                  </p>
                  <p
                    class="
                                            font-metropolis-regular font-14
                                            pt-0
                                        "
                  >
                    {{ $t('cart.total') }}
                    {{ currencyName }}
                    {{ surcharges }}
                  </p>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12" class="pa-0">
                  <v-btn
                    :loading="loading"
                    :disabled="isButtonDisabled"
                    class="
                                            mt-5
                                            lowercase
                                            br-0
                                            pl-10
                                            pr-10
                                            font-syne-bold
                                        "
                    color="badge"
                    @click="validateForm"
                  >
                    {{ $t('buttons.confirmOrder') }}
                  </v-btn>
                </v-col>
              </v-row>
            </v-col>
          </v-row>
        </v-col>

        <v-col md="3">
          <v-row>
            <v-col cols="12" class="pt-0">
              <p
                v-if="cartItems.length === 0"
                class="box-title-text text-center"
              >
                {{ $t('common.addToSideBox') }}
              </p>
              <div v-else>
                <!-- SUBSCRIBED PLAN -->
                <v-row>
                  <v-col
                    md="10"
                    cols="12"
                    offset-md="1"
                    class="pt-0"
                  >
                    <v-col class="pl-0 pt-0">
                      <h3
                        v-if="planDetails"
                        class="font-syne-bold"
                      >
                        {{ planDetails.name }}
                      </h3>
                      <h3 v-else class="font-syne-bold">
                        {{ $t('common.yourBox') }}
                      </h3>
                    </v-col>
                    <v-divider />
                  </v-col>
                </v-row>

                <v-row
                  v-for="(i, items) of cartItems"
                  :key="'cart-' + items"
                >
                  <v-col cols="3" offset-md="1">
                    <v-img
                      v-if="i.image"
                      :src="i.image.url"
                    />
                  </v-col>
                  <v-col cols="5">
                    <p class="product-title-text mb-1">
                      {{ i.brand.name }} {{ i.name }}
                    </p>
                    <p class="product-desc-text mb-1">
                      {{ i.option.name }}
                    </p>
                    <p class="product-desc-text mb-1">
                      {{ currencyName }}
                      {{ i.price[currency].price }}
                    </p>
                  </v-col>
                </v-row>

                <!-- TOTAL AMOUNT -->
                <v-row>
                  <v-col md="10" cols="12" offset-md="1">
                    <v-divider />

                    <!-- ITEMS VALUE -->
                    <v-row>
                      <v-col cols="6" class="pb-0">
                        <p
                          class="
                                                        cart-text
                                                        text-white
                                                        mb-0
                                                    "
                        >
                          {{ $t('cart.retailValue') }}
                        </p>
                      </v-col>
                      <v-col
                        cols="6"
                        class="text-right pb-0"
                      >
                        <p
                          class="
                                                        cart-text
                                                        text-white
                                                        mb-0
                                                    "
                        >
                          {{ currencyName }}
                          {{ getTotalCartPrice }}
                        </p>
                      </v-col>
                      <v-col
                        v-if="
                          $vuetify.breakpoint
                            .smAndDown
                        "
                        cols="12"
                      >
                        <v-btn
                          :loading="loading"
                          :disabled="isButtonDisabled"
                          class="
                                                        mt-5
                                                        lowercase
                                                        br-0
                                                        pl-10
                                                        pr-10
                                                        font-syne-bold
                                                    "
                          color="badge"
                          block
                          @click="validateForm"
                        >
                          {{
                            $t(
                              'buttons.confirmOrder'
                            )
                          }}
                        </v-btn>
                      </v-col>
                    </v-row>
                  </v-col>
                </v-row>
              </div>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-form>
  </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import moment from 'moment'

@Component<any>({
  middleware: ['authenticate'],
  head () {
    return {
      title: this.$t('common.checkout')
    }
  },
  computed: mapGetters({
    menus: 'menu/getMenu',
    menuDashboard: 'menu/getMenuDashboard',
    currency: 'currency/getCurrency',
    currencyName: 'currency/getCurrencyName',
    cartItems: 'cart/getCartItems',
    cartPrice: 'cart/getCartPrice',
    surcharges: 'cart/getSurcharges',
    planDetails: 'subscription/getPlanDetails',
    addresses: 'user/getAddresses',
    shippingAddress: 'user/getShippingAddress',
    selectedShippingAddress: 'user/getSelectedShippingAddress'
  })
})
export default class Checkout extends Vue {
    // Data
    $refs!: {
        checkoutForm: HTMLFormElement
        addressForm: HTMLFormElement
        datePick: HTMLFormElement
    }

    ref: any = this.$refs
    pageLoaded: boolean = false
    menus!: any
    menuDashboard!: any
    cartItems!: any
    planDetails!: any
    cartPrice!: Function
    selectedShippingAddress!: Function
    currency!: number
    currencyName!: string
    shippingAddress!: any
    newShippingAddress: boolean = false
    loading: Boolean = false
    showPass: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
      firstName: {
        value: '',
        error: null,
        requestKey: 'first_name'
      },
      lastName: {
        value: '',
        error: null,
        requestKey: 'last_name'
      },
      mobile: {
        value: '',
        error: null,
        requestKey: 'mobile'
      },
      company: {
        value: '',
        error: null,
        requestKey: 'company'
      },
      address1: {
        value: '',
        error: null,
        requestKey: 'address_1'
      },
      address2: {
        value: '',
        error: null,
        requestKey: 'address_2'
      },
      city: {
        value: '',
        error: null,
        requestKey: 'city'
      },
      state: {
        value: '',
        error: null,
        requestKey: 'state'
      },
      country: {
        value: '',
        error: null,
        requestKey: 'country'
      },
      postcode: {
        value: '',
        error: null,
        requestKey: 'postcode'
      },
      deliveryTime: {
        value: '',
        error: null,
        requestKey: 'delivery_time'
      }
    }

    countryList: any = ['Malaysia']
    menu1: any = false
    todayDate: any = new Date().setDate(new Date().getDate())
    tomorrowDate: any = new Date(this.todayDate)
    disabledDates: any = {
      to: this.tomorrowDate,
      days: [6, 0] // Disable Saturday's and Sunday's
    }

    timeslots: any = []

    deliveryDate: any = ''
    extraFeeTooltip: Boolean = false
    deleteItem: any = []
    isButtonDisabled = false
    isAddAddressBtnDisabled: boolean = false
    isAddAddressLoaderBtnDisabled: boolean = false
    addressGroup: number = 1
    panel: number = 1

    // Rules
    requiredRules (v: string) {
      if (v) {
        return true
      } else {
        return this.$t('form.validation.required')
      }
    }

    // Computed
    get getTotalCartPrice () {
      return this.cartPrice(this.currency)
    }

    // Methods
    async removeFromBox (product: any = {}) {
      // push product id to delete array
      if (!this.deleteItem.includes(product.id)) {
        this.deleteItem.push(product.id)
      }

      // delete from cart
      const response = await this.$api.cart.remove(product.id, 1)

      if (response.data) {
        this.$store.dispatch('cart/removeFromCart', product)
        const val: {} = {
          text: this.$t('notification.cart.removed'),
          color: 'green',
          icon: 'mdi-check'
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)

        // remove product id from delete array
        if (this.deleteItem.includes(product.id)) {
          const index = this.deleteItem.indexOf(product.id)
          this.deleteItem.splice(index, 1)
        }
      } else {
        const val: {} = {
          text: this.$t('notification.cart.removed_failed'),
          color: 'red',
          icon: 'mdi-alert'
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
      }
    }

    validateAddressForm () {
      if (typeof this.$refs === 'undefined') {
        return
      }

      setTimeout(() => {
        const valid = this.$refs.addressForm.validate()

        if (valid) {
          this.newShippingAddress = true
          this.isAddAddressBtnDisabled = true
          this.addressGroup = 0
        }
      }, 300)
    }

    validateForm () {
      if (typeof this.$refs === 'undefined') {
        return
      }

      setTimeout(() => {
        const valid = this.$refs.checkoutForm.validate()

        if (valid) {
          if (!this.deliveryDate) {
            const val = {
              text: this.$t('notification.date.required'),
              color: 'white',
              icon: 'mdi-alert'
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
            this.isButtonDisabled = false
          } else {
            this.checkout()
          }
        }
      }, 300)
    }

    gotoAddress () {
      this.$router.push('dashboard/address/add')
    }

    addNewAddress () {
      if (this.panel === 1) {
        this.panel = 0
      } else {
        this.panel = 1
      }
    }

    selectAddress () {
      this.newShippingAddress = false
      this.isAddAddressBtnDisabled = false
    }

    checkout () {
      let shippingAddress
      this.loading = true
      this.isButtonDisabled = true

      // Redirect to subscription page if no subscription is found
      if (!this.planDetails) {
        this.loading = false
        this.isButtonDisabled = false
        const val: {} = {
          text: this.$t('notification.subscription.required'),
          color: 'white',
          icon: 'mdi-alert'
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)

        this.$router.push(this.menuDashboard.SUBSCRIPTION.path)
      }

      // new shipping address
      if (this.newShippingAddress) {
        shippingAddress = {
          first_name: this.form.firstName.value,
          last_name: this.form.lastName.value,
          mobile: this.form.mobile.value,
          company: this.form.company.value,
          address_1: this.form.address1.value,
          address_2: this.form.address2.value,
          city: this.form.city.value,
          state: this.form.state.value,
          country: this.form.country.value,
          postcode: this.form.postcode.value
        }
      } else if (this.addressGroup === 0) {
        const selectedAddress = this.selectedShippingAddress(
          this.addressGroup
        )
        shippingAddress = {
          first_name: selectedAddress.firstName,
          last_name: selectedAddress.lastName,
          mobile: selectedAddress.mobile,
          company: selectedAddress.company,
          address_1: selectedAddress.address1,
          address_2: selectedAddress.address2,
          city: selectedAddress.city,
          state: selectedAddress.state,
          country: selectedAddress.country,
          postcode: selectedAddress.postcode
        }
      }

      // Call checkout API
      this.$api.checkout
        .checkout(
          shippingAddress,
          this.currencyName.toLowerCase(),
          this.formatDate(this.deliveryDate),
          this.form.deliveryTime.value
        )
        .then(() => {
          const val = {
            text: this.$t('notification.checkout.success'),
            color: 'green',
            icon: 'mdi-check'
          }
          this.$store.dispatch('snackbar/displaySnackBar', val)

          // Clear cart
          this.$store.commit('cart/clearCart')

          // Reopen button
          this.loading = false
          this.isButtonDisabled = false

          this.$router.push(this.menuDashboard.ORDERS.path)
        })
        .catch((error) => {
          this.loading = false
          this.isButtonDisabled = false
          // Get errors object
          if (error.response?.status === 400) {
            // Clear cart
            // this.$store.commit('cart/clearCart')
            const val = {
              text: error.response.data.message,
              color: 'white',
              icon: 'mdi-alert'
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
          }
        })
    }

    async getTimeslots () {
      const timeslots = await this.$api.timeslot.getTimeslots()
      if (timeslots.data.data.length > 0) {
        for (const key of timeslots.data.data) {
          // deliver timeslots
          if (key.type_id === 1) {
            const convertStartTime = moment().format(
              'YYYY-MM-DD ' + key.start_time
            )
            const newStartTime = moment(convertStartTime)
              .add(8, 'hours')
              .format('HH:mm')

            const convertEndTime = moment().format(
              'YYYY-MM-DD ' + key.end_time
            )
            const newEndTime = moment(convertEndTime)
              .add(8, 'hours')
              .format('HH:mm')

            const suffixStart =
                        parseInt(newStartTime) >= 12 ? 'PM' : 'AM'
            const suffixEnd = parseInt(newEndTime) >= 12 ? 'PM' : 'AM'
            const timeStart =
                        ((parseInt(newStartTime) + 11) % 12) + 1 + suffixStart
            const timeEnd =
                        ((parseInt(newEndTime) + 11) % 12) + 1 + suffixEnd

            const obj = {
              id: key.id,
              name: timeStart + ' - ' + timeEnd
            }
            this.timeslots.push(obj)
          }
        }
      }
    }

    mounted () {
      this.getTimeslots()
      this.addressGroup = this.shippingAddress.id

      if (this.cartItems.length === 0) {
        this.$router.push(this.menuDashboard.HOME.path)
      }

      if (typeof this.$refs !== 'undefined') {
        this.ref = this.$refs
        this.pageLoaded = true
      }
    }

    formatDate (date) {
      return moment(date).format('yyyy-MM-DD')
    }
}
</script>
